<?php if ( ! defined( 'ABSPATH' ) ) exit;

final class PFORM_Admin_Menus_Aboutus extends PFORM_Abstracts_Submenu
{
    public $parent_slug = 'pie-forms';

    public $menu_slug = 'pf-aboutus';

    public $priority = 15;

    protected $_prefix = 'pie_forms';

    public function get_page_title()
    {
        $indicator = '';
		if ( ! empty( Pie_Forms()->core()->has_notifications() ) ) {
			$indicator     = Pie_Forms()->core()->has_notifications() !== 0  ? '<div class="pieforms-menu-notification-indicator"></div>' : ''; 
		}

        return __( 'About Us'.$indicator, 'pie-forms' );
    }

    public function get_capability()
    {
        return $this->capability;
    }

    public function display()
    {
        wp_enqueue_style('AboutPage', Pie_Forms::$url . 'assets/css/aboutus.css', array(), Pie_Forms::VERSION );
        wp_register_script( 'AboutPage', Pie_Forms::$url . 'assets/js/aboutus.js', array(), Pie_Forms::VERSION );
        wp_enqueue_script( 'AboutPage' );
        
        // Notification
        wp_enqueue_style('NotificationCSS', Pie_Forms::$url . 'assets/css/notification.css', array(),  Pie_Forms::VERSION);
        wp_register_script( 'NotificationJs', Pie_Forms::$url . 'assets/js/notification.js', array(),  Pie_Forms::VERSION);
        wp_enqueue_script( 'NotificationJs' );
        wp_localize_script( 'NotificationJs', 'pie_forms', array(
            'nonce'                   => wp_create_nonce( 'pie-forms-admin' ),
            'ajax_url'                => admin_url( 'admin-ajax.php' ),
        ) );
        Pie_Forms::template( 'aboutus.php' );
    }

} // End Class PFORM_Admin_Menus_Aboutus
