<?php if ( ! defined( 'ABSPATH' ) ) exit;

final class PFORM_Admin_Menus_Main extends PFORM_Abstracts_Menu
{
    public $page_title = 'Pie Forms';

    public $menu_slug = 'pie-forms';

    public $icon_url = 'dashicons-text-page';

    public $position = '38';

    public $ver = Pie_Forms::VERSION;
    public $field_type_settings = array();

    public function __construct()
    {
        parent::__construct();

            

    }


    public function get_page_title()
    {
        return esc_html__( 'Pie Forms', 'pie-forms' );
    }

  
    public function display()
    {
        // Notification
        wp_enqueue_style('NotificationCSS', Pie_Forms::$url . 'assets/css/notification.css', array(),  Pie_Forms::VERSION);
        wp_register_script( 'NotificationJs', Pie_Forms::$url . 'assets/js/notification.js', array(),  Pie_Forms::VERSION );
        wp_enqueue_script( 'NotificationJs' );
        wp_localize_script( 'NotificationJs', 'pie_forms', array(
            'nonce'                   => wp_create_nonce( 'pie-forms-admin' ),
            'ajax_url'                => admin_url( 'admin-ajax.php' ),
        ) );
        
        if( !isset($_GET[ 'form_id' ]) && $_GET['page'] == $this->menu_slug) {
        
            do_action( 'pie_forms_admin_pages_before_content' ); 
        ?>
            <div class="wrap">
                <h1 class="wp-heading-inline"><?php esc_html_e( 'All Forms', 'pie-forms' ); ?></h1>
                <a href="<?php echo esc_url( admin_url( 'admin.php?page=pie-addnew' ) ); ?>" class="page-title-action"><?php esc_html_e( 'New Form', 'pie-forms' ); ?></a>
                <?php
                    $table_data      = new PFORM_Admin_AllFormTable();
                ?>
            </div>            

            <?php
            
            $arguments = array(
                'label'     =>  __( 'Users Per Page', 'pie-forms' ),
                'default'   =>  5,
                'option'    =>  'pie_form_per_page'
            );
            add_screen_option( 'per_page', $arguments );

            wp_enqueue_style('TableGrid', Pie_Forms::$url . 'assets/css/admin-table.css', array(), Pie_Forms::VERSION );
        }

    }

  
    public function get_capability()
    {
        return apply_filters( 'pie_forms_admin_parent_menu_capabilities', $this->capability );

    }

   /*  public function screen_option(){
      return true;
    }
 */
}
