<?php

defined( 'ABSPATH' ) || exit;

class PFORM_Settings_Licence extends PFORM_Abstracts_Settings {

	/**
	 * Constructor.
	 */
	public function __construct() {
		$this->id    = 'licence';
		$this->label = esc_html__( 'licence Key', 'pie-forms' );

		parent::__construct();
	}
	
	/**
	 * Get settings array.
	 */
	public function get_settings() {
		$active = Pie_Forms()->core()->pform_check_addon_exist('pie-forms-for-wp-multipart-forms/pie-forms-for-wp-multipart-forms.php') ? true : false;
		$not_active = Pie_Forms()->core()->pform_check_addon_exist('pie-forms-for-wp-multipart-forms/pie-forms-for-wp-multipart-forms.php')  || Pie_Forms()->core()->pform_check_addon_exist('pie-forms-for-wp-protected/pie-forms-for-wp-protected.php')? false : true;
		$active_protected = Pie_Forms()->core()->pform_check_addon_exist('pie-forms-for-wp-protected/pie-forms-for-wp-protected.php') ? true : false;

		$settings = apply_filters(
			'pie_forms_licence_settings',
			array(
				array(
					'title' => esc_html__( 'Activate Addons Licence Settings', 'pie-forms' ),
					'type'  => 'title',
					'id'    => 'licence_settings',
				),
				array(
					'title' 		=> esc_html__( 'Upgrade To Premium Version', 'pie-forms' ),
					'type'  		=> 'upgrade',
					'id'    		=> 'upgrade_to_pro',
					'class'    		=> 'pie-forms-upgrade',
					'is_visible'	=> $not_active
				),
				array(
					'title'			=> esc_html__('Multipage Forms Addon' , 'pie-forms'),
					'type'			=> 'addons_license',
					'id'			=> 'multipart',
					'email_address'	=> array(
						'placeholder'   => esc_html__( 'Email Address', 'pie-forms' ),
						'desc'     		=> esc_html__( '', 'pie-forms' ),
						'id'       		=> 'pieforms_addon_multipart_licence_email',
 						'default'  		=> '',

					),
					'license_key'	=> array(
						'placeholder'   => esc_html__( 'License key', 'pie-forms' ),
						'desc'     		=> esc_html__( '', 'pie-forms' ),
						'id'       		=> 'pieforms_addon_multipart_licence_key',
						'default'  		=> '',
					),
					'is_visible'	=> $active
				),
				array(
					'title'			=> esc_html__('Password Protected Addon' , 'pie-forms'),
					'type'			=> 'addons_license',
					'id'			=> 'protected',
					'email_address'	=> array(
						'placeholder'   => esc_html__( 'Email Address', 'pie-forms' ),
						'desc'     		=> esc_html__( '', 'pie-forms' ),
						'id'       		=> 'pieforms_addon_protected_licence_email',
 						'default'  		=> '',

					),
					'license_key'	=> array(
						'placeholder'   => esc_html__( 'License key', 'pie-forms' ),
						'desc'     		=> esc_html__( '', 'pie-forms' ),
						'id'       		=> 'pieforms_addon_protected_licence_key',
						'default'  		=> '',
					),
					'is_visible'	=> $active_protected
				),
				array(
					'type' => 'sectionend',
					'id'   => 'licence_settings',
				),
			)
		);

		return apply_filters( 'pie_forms_get_settings_' . $this->id, $settings );
	}

	/**
	 * Save settings.
	 */
	public function save() {
		$settings = $this->get_settings();

		PFORM_Admin_Settings::save_fields( $settings );
	}
}